clear all, close all;
%load divided .csv file

load('gps.mat');
load('gps2.mat');

% receiver location based on average value
true_Alt=mean(AltMSL(3:41000))
true_Lat=mean(Lat(3:41000))
true_Lon=mean(Lon(3:41000))

%mean(SVCN0(3:41000))
%std(SVCN0(3:41000))
%mean(SVsR(3:41000))
%std(SVsR(3:41000))
 
%do not cound values greater than 100
SVG1ResidualL1CA(SVG1ResidualL1CA>100)=0;SVG2ResidualL1CA(SVG2ResidualL1CA>100)=0;SVG3ResidualL1CA(SVG3ResidualL1CA>100)=0;SVG4ResidualL2CL(SVG4ResidualL2CL>100)=0;
SVG5ResidualL1CA(SVG5ResidualL1CA>100)=0;SVG6ResidualL1CA(SVG6ResidualL1CA>100)=0;SVG7ResidualL1CA(SVG7ResidualL1CA>100)=0;SVG8ResidualL1CA(SVG8ResidualL1CA>100)=0;
SVG9ResidualL1CA(SVG9ResidualL1CA>100)=0;SVG10ResidualL1CA(SVG10ResidualL1CA>100)=0;SVG12ResidualL1CA(SVG12ResidualL1CA>100)=0;
SVG13ResidualL1CA(SVG13ResidualL1CA>100)=0;SVG14ResidualL1CA(SVG14ResidualL1CA>100)=0;SVG15ResidualL1CA(SVG15ResidualL1CA>100)=0;SVG16ResidualL1CA(SVG16ResidualL1CA>100)=0;
SVG17ResidualL1CA(SVG17ResidualL1CA>100)=0;SVG18ResidualL1CA(SVG18ResidualL1CA>100)=0;SVG19ResidualL1CA(SVG19ResidualL1CA>100)=0;SVG20ResidualL1CA(SVG20ResidualL1CA>100)=0;
SVG21ResidualL1CA(SVG21ResidualL1CA>100)=0;SVG22ResidualL1CA(SVG22ResidualL1CA>100)=0;SVG23ResidualL1CA(SVG23ResidualL1CA>100)=0;SVG24ResidualL1CA(SVG24ResidualL1CA>100)=0;
SVG25ResidualL1CA(SVG25ResidualL1CA>100)=0;SVG26ResidualL1CA(SVG26ResidualL1CA>100)=0;SVG27ResidualL1CA(SVG27ResidualL1CA>100)=0;SVG28ResidualL1CA(SVG28ResidualL1CA>100)=0;
SVG29ResidualL1CA(SVG29ResidualL1CA>100)=0;SVG30ResidualL1CA(SVG30ResidualL1CA>100)=0;SVG31ResidualL1CA(SVG31ResidualL1CA>100)=0;SVG32ResidualL1CA(SVG32ResidualL1CA>100)=0;

% res_gps_nnz function return number of non zero elements 
% res_gps_range return vectors with residual range error for each position
res_gps_nnz = abs(nnz(SVG1ResidualL1CA(3:41000))+nnz(SVG2ResidualL1CA(3:41000))+nnz(SVG3ResidualL1CA(3:41000))+nnz(SVG5ResidualL1CA(3:41000))+nnz(SVG6ResidualL1CA(3:41000))+nnz(SVG7ResidualL1CA(3:41000))+nnz(SVG8ResidualL1CA(3:41000))+nnz(SVG9ResidualL1CA(3:41000))+nnz(SVG10ResidualL1CA(3:41000))+nnz(SVG12ResidualL1CA(3:41000))+nnz(SVG13ResidualL1CA(3:41000))+nnz(SVG14ResidualL1CA(3:41000))+nnz(SVG15ResidualL1CA(3:41000))+nnz(SVG16ResidualL1CA(3:41000))+nnz(SVG17ResidualL1CA(3:41000))+nnz(SVG18ResidualL1CA(3:41000))+nnz(SVG19ResidualL1CA(3:41000))+nnz(SVG20ResidualL1CA(3:41000))+nnz(SVG21ResidualL1CA(3:41000))+nnz(SVG22ResidualL1CA(3:41000))+nnz(SVG23ResidualL1CA(3:41000))+nnz(SVG24ResidualL1CA(3:41000))+nnz(SVG25ResidualL1CA(3:41000))+nnz(SVG26ResidualL1CA(3:41000))+nnz(SVG27ResidualL1CA(3:41000))+nnz(SVG28ResidualL1CA(3:41000))+nnz(SVG29ResidualL1CA(3:41000))+nnz(SVG30ResidualL1CA(3:41000))+nnz(SVG31ResidualL1CA(3:41000))+nnz(SVG32ResidualL1CA(3:41000)));
res_gps_range=((abs(SVG1ResidualL1CA(3:41000))+abs(SVG2ResidualL1CA(3:41000))+abs(SVG3ResidualL1CA(3:41000))+abs(SVG5ResidualL1CA(3:41000))+abs(SVG6ResidualL1CA(3:41000))+abs(SVG7ResidualL1CA(3:41000))+abs(SVG8ResidualL1CA(3:41000))+abs(SVG9ResidualL1CA(3:41000))+abs(SVG10ResidualL1CA(3:41000))+abs(SVG12ResidualL1CA(3:41000))+abs(SVG13ResidualL1CA(3:41000))+abs(SVG14ResidualL1CA(3:41000))+abs(SVG15ResidualL1CA(3:41000))+abs(SVG16ResidualL1CA(3:41000))+abs(SVG17ResidualL1CA(3:41000))+abs(SVG18ResidualL1CA(3:41000))+abs(SVG19ResidualL1CA(3:41000))+abs(SVG20ResidualL1CA(3:41000))+abs(SVG21ResidualL1CA(3:41000))+abs(SVG22ResidualL1CA(3:41000))+abs(SVG23ResidualL1CA(3:41000))+abs(SVG24ResidualL1CA(3:41000))+abs(SVG25ResidualL1CA(3:41000))+abs(SVG26ResidualL1CA(3:41000))+abs(SVG27ResidualL1CA(3:41000))+abs(SVG28ResidualL1CA(3:41000))+abs(SVG29ResidualL1CA(3:41000))+abs(SVG30ResidualL1CA(3:41000))+abs(SVG31ResidualL1CA(3:41000))+abs(SVG32ResidualL1CA(3:41000)))/res_gps_nnz)*length(SVG1ResidualL1CA(3:41000));

%vectors for X axes
meters_coordinates = 0:0.01:30;
meters_altitude = 0:0.01:30;
meters_residual_range = 0:0.01:30;

% std_error_3D=std((((X(3:41000)-mean(X(3:41000))).^2)+((Y(3:41000)-mean(Y(3:41000))).^2)+((Z(3:41000)-mean(Z(3:41000))).^2)).^0.5)

% mean_error_3D=mean((((X(3:41000)-mean(X(3:41000))).^2)+((Y(3:41000)-mean(Y(3:41000))).^2)+((Z(3:41000)-mean(Z(3:41000))).^2)).^0.5)
% std_error_3Db=((std(X(3:41000))^2)+(std(Y(3:41000))^2)+(std(Z(3:41000))^2)).^0.5

% mean_error_Alt=mean(abs(AltMSL(3:41000)-mean(AltMSL(3:41000))))
%mean_error_Alt=mean(abs(AltMSL(3:41000)-true_Alt))

%counting vectors with error values for each type of data (coordinates, latitude, longtitude, altitude)
hist_error_3D=hist((((X(3:41000)-mean(X(3:41000))).^2)+((Y(3:41000)-mean(Y(3:41000))).^2)+((Z(3:41000)-mean(Z(3:41000))).^2)).^0.5, (meters_coordinates))/length(X(3:41000));
hist_error_Alt=hist(abs(AltMSL(3:41000)-mean(AltMSL(3:41000))),(meters_altitude))/length(AltMSL(3:41000));
hist_res_range=hist(abs((res_gps_range-mean(res_gps_range))),(meters_residual_range))/length(res_gps_range);

error_Lat=(Lat(3:41000)-true_Lat)*111317.1;
error_Lon=(Lon(3:41000)-true_Lon)*71968.6;

hist_error_2D=hist((error_Lat.^2+error_Lon.^2).^0.5,(meters_coordinates))/length(Lat(3:41000));
%hist_error_SVs=hist(abs(SVsReceived(3:41000)-mean(SVsReceived(3:41000))),(0:1:max(SVsReceived)))/length(SVsReceived(3:41000));

std_2D=(std(error_Lat)^2+std(error_Lon)^2)^0.5;

for i=1:length(hist_error_2D)
    distr_error_3D(i)=sum(hist_error_3D(1:i));
    distr_error_2D(i)=sum(hist_error_2D(1:i));
    
    
end;

for i=1:length(hist_error_Alt)
    distr_error_Alt(i)=sum(hist_error_Alt(1:i));
end;

for i=1:length(hist_res_range)
    distr_res_range(i)=sum(hist_res_range(1:i));
end;

%graph of the probability
figure("Name","Probability")
subplot(2,2,1);
first = plot((meters_coordinates),distr_error_3D);
title("Probability of GPS distortion - coordinates X,Y,Z");
xlabel("meters_coordinates");
ylabel("Probability");
xlim([0 max(meters_coordinates)]);
ylim([0 1]);


%figure(2)
subplot(2,2,2);
plot((meters_coordinates),distr_error_2D);
title("Probability of GPS distortion - Latitude, Longtitude");
xlabel("meters_coordinates");
ylabel("Probability");
xlim([0 max(meters_coordinates)]);
ylim([0 1]);

%figure(3)
subplot(2,2,3);
plot((meters_altitude),distr_error_Alt);
title("Probability of GPS distortion - Altitude");
xlabel("meters_coordinates");
ylabel("Probability");
xlim([0 max(meters_altitude)]);
ylim([0 1]);

%figure(4)
subplot(2,2,4);
plot((meters_residual_range),distr_res_range);
title("Probability of GPS distortion - residual range");
xlabel("Range in meters");
ylabel("Probability");

figure("Name",'Histogram')
histogram(SVsReceived);
title("GPS Histogram - Used SVs coresponding to number of samples");
xlabel("Number of satellites");
ylabel("Number of samples");
